test-release.sh 20 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606
  1. #!/bin/bash
  2. # Tested on Linux, Armbian, Raspbian, MSYS2
  3. REFDIR='test/ref'
  4. SUDO='sudo'
  5. if [ "$(uname -m)" == 'armv7l' ]; then
  6. ARM32=1
  7. elif uname -a | grep -q 'MSYS'; then
  8. SUDO='' MSYS2=1;
  9. fi
  10. trap 'echo -e "${GREEN}Exiting at user request$RESET"; exit' INT
  11. umask 0022
  12. export MMGEN_TEST_SUITE=1
  13. export MMGEN_NO_LICENSE=1
  14. export PYTHONPATH=.
  15. test_py='test/test.py -n'
  16. objtest_py='test/objtest.py'
  17. objattrtest_py='test/objattrtest.py'
  18. colortest_py='test/colortest.py'
  19. unit_tests_py='test/unit_tests.py --names --quiet'
  20. tooltest_py='test/tooltest.py'
  21. tooltest2_py='test/tooltest2.py --names --quiet'
  22. gentest_py='test/gentest.py --quiet'
  23. scrambletest_py='test/scrambletest.py'
  24. altcoin_py='mmgen/altcoin.py --quiet'
  25. mmgen_tool='cmds/mmgen-tool'
  26. mmgen_keygen='cmds/mmgen-keygen'
  27. python='python3'
  28. rounds=100 rounds_min=20 rounds_mid=250 rounds_max=500
  29. dfl_tests='dep misc obj color unit hash ref altref alts xmr eth autosign btc btc_tn btc_rt bch bch_rt ltc ltc_rt tool tool2 gen'
  30. extra_tests='dep autosign_btc autosign_live etc ltc_tn bch_tn'
  31. noalt_tests='dep misc obj color unit hash ref autosign_btc btc btc_tn btc_rt tool tool2 gen'
  32. quick_tests='dep misc obj color unit hash ref altref alts xmr eth autosign btc btc_rt tool tool2 gen'
  33. qskip_tests='btc_tn bch bch_rt ltc ltc_rt'
  34. PROGNAME=$(basename $0)
  35. while getopts hAbCDfFi:I:lNOps:tvV OPT
  36. do
  37. case "$OPT" in
  38. h) printf " %-16s Test MMGen release\n" "${PROGNAME}:"
  39. echo " USAGE: $PROGNAME [options] [tests or test group]"
  40. echo " OPTIONS: -h Print this help message"
  41. echo " -A Skip tests requiring altcoin modules or daemons"
  42. echo " -b Buffer keypresses for all invocations of 'test/test.py'"
  43. echo " -C Run tests in coverage mode"
  44. echo " -D Run tests in deterministic mode"
  45. echo " -f Speed up the tests by using fewer rounds"
  46. echo " -F Reduce rounds even further"
  47. echo " -i BRANCH Create and install Python package from cloned BRANCH, then"
  48. echo " run tests in installed package"
  49. echo " -I BRANCH Like '-i', but install the package without running the tests"
  50. echo " -l List the test name symbols"
  51. echo " -N Pass the --no-timings switch to test/test.py"
  52. echo " -O Use pexpect.spawn rather than popen_spawn where applicable"
  53. echo " -p Pause between tests"
  54. echo " -s LIST Skip tests in LIST (space-separated)"
  55. echo " -t Print the tests without running them"
  56. echo " -v Run test/test.py with '--exact-output' and other commands"
  57. echo " with '--verbose' switch"
  58. echo " -V Run test/test.py and other commands with '--verbose' switch"
  59. echo
  60. echo " AVAILABLE TESTS:"
  61. echo " obj - data objects"
  62. echo " color - color handling"
  63. echo " unit - unit tests"
  64. echo " hash - internal hash function implementations"
  65. echo " ref - reference file checks"
  66. echo " altref - altcoin reference file checks"
  67. echo " alts - operations for all supported gen-only altcoins"
  68. echo " xmr - Monero xmrwallet operations"
  69. echo " eth - operations for Ethereum"
  70. echo " etc - operations for Ethereum Classic"
  71. echo " autosign - autosign"
  72. echo " btc - bitcoin"
  73. echo " btc_tn - bitcoin testnet"
  74. echo " btc_rt - bitcoin regtest"
  75. echo " bch - bitcoin cash (BCH)"
  76. echo " bch_tn - bitcoin cash (BCH) testnet"
  77. echo " bch_rt - bitcoin cash (BCH) regtest"
  78. echo " ltc - litecoin"
  79. echo " ltc_tn - litecoin testnet"
  80. echo " ltc_rt - litecoin regtest"
  81. echo " tool - tooltest (all supported coins)"
  82. echo " tool2 - tooltest2 (all supported coins)"
  83. echo " gen - gentest (all supported coins)"
  84. echo " misc - miscellaneous tests that don't fit in the above categories"
  85. echo
  86. echo " AVAILABLE TEST GROUPS:"
  87. echo " default - All tests minus the extra tests"
  88. echo " extra - All tests minus the default tests"
  89. echo " noalt - BTC-only tests"
  90. echo " quick - Default tests minus btc_tn, bch, bch_rt, ltc and ltc_rt"
  91. echo " qskip - The tests skipped in the 'quick' test group"
  92. echo
  93. echo " By default, all tests are run"
  94. exit ;;
  95. A) SKIP_ALT_DEP=1 unit_tests_py+=" --no-altcoin-deps" ;;
  96. b) test_py+=" --buf-keypress" ;;
  97. C) mkdir -p 'test/trace'
  98. touch 'test/trace.acc'
  99. test_py+=" --coverage"
  100. tooltest_py+=" --coverage"
  101. tooltest2_py+=" --fork --coverage"
  102. scrambletest_py+=" --coverage"
  103. python="python3 -m trace --count --file=test/trace.acc --coverdir=test/trace"
  104. unit_tests_py="$python $unit_tests_py"
  105. objtest_py="$python $objtest_py"
  106. objattrtest_py="$python $objattrtest_py"
  107. gentest_py="$python $gentest_py"
  108. mmgen_tool="$python $mmgen_tool"
  109. mmgen_keygen="$python $mmgen_keygen" ;&
  110. D) export MMGEN_TEST_SUITE_DETERMINISTIC=1
  111. export MMGEN_DISABLE_COLOR=1 ;;
  112. f) FAST=1 rounds=10 rounds_min=3 rounds_mid=25 rounds_max=50 unit_tests_py+=" --fast" ;;
  113. F) FAST=1 rounds=3 rounds_min=1 rounds_mid=3 rounds_max=5 unit_tests_py+=" --fast" ;;
  114. i) INSTALL=$OPTARG ;;
  115. I) INSTALL=$OPTARG INSTALL_ONLY=1 ;;
  116. l) echo -e "Default tests:\n $dfl_tests"
  117. echo -e "Extra tests:\n $extra_tests"
  118. echo -e "'noalt' test group:\n $noalt_tests"
  119. echo -e "'quick' test group:\n $quick_tests"
  120. echo -e "'qskip' test group:\n $qskip_tests"
  121. exit ;;
  122. N) test_py+=" --no-timings" ;;
  123. O) test_py+=" --pexpect-spawn" ;;
  124. p) PAUSE=1 ;;
  125. s) SKIP_LIST="$OPTARG" ;;
  126. t) LIST_CMDS=1 ;;
  127. v) EXACT_OUTPUT=1 test_py+=" --exact-output" ;&
  128. V) VERBOSE=1
  129. [ "$EXACT_OUTPUT" ] || test_py+=" --verbose"
  130. unit_tests_py="${unit_tests_py/--quiet/--verbose}"
  131. altcoin_py="${altcoin_py/--quiet/--verbose}"
  132. tooltest2_py="${tooltest2_py/--quiet/--verbose}"
  133. gentest_py="${gentest_py/--quiet/--verbose}"
  134. tooltest_py+=" --verbose"
  135. mmgen_tool+=" --verbose"
  136. objattrtest_py+=" --verbose"
  137. scrambletest_py+=" --verbose" ;;
  138. *) exit ;;
  139. esac
  140. done
  141. [ "$MMGEN_DISABLE_COLOR" ] || {
  142. RED="\e[31;1m" GREEN="\e[32;1m" YELLOW="\e[33;1m" BLUE="\e[34;1m" MAGENTA="\e[35;1m" CYAN="\e[36;1m"
  143. RESET="\e[0m"
  144. }
  145. [ "$MSYS2" -a ! "$FAST" ] && tooltest2_py+=' --fork'
  146. [ "$EXACT_OUTPUT" -o "$VERBOSE" ] || objtest_py+=" -S"
  147. shift $((OPTIND-1))
  148. case $1 in
  149. '') tests=$dfl_tests ;;
  150. 'default') tests=$dfl_tests ;;
  151. 'extra') tests=$extra_tests ;;
  152. 'noalt') tests=$noalt_tests SKIP_ALT_DEP=1 unit_tests_py+=" --no-altcoin-deps" ;;
  153. 'quick') tests=$quick_tests ;;
  154. 'qskip') tests=$qskip_tests ;;
  155. *) tests="$*" ;;
  156. esac
  157. [ "$INSTALL" ] && {
  158. BRANCH=$INSTALL
  159. BRANCHES=$(git branch)
  160. FOUND_BRANCH=$(for b in ${BRANCHES/\*}; do [ "$b" == "$BRANCH" ] && echo ok; done)
  161. [ "$FOUND_BRANCH" ] || { echo "Branch '$BRANCH' not found!"; exit; }
  162. }
  163. set -e
  164. check() {
  165. [ "$BRANCH" ] || { echo 'No branch specified. Exiting'; exit; }
  166. [ "$(git diff $BRANCH)" == "" ] || {
  167. echo "Unmerged changes from branch '$BRANCH'. Exiting"
  168. exit 1
  169. }
  170. git diff $BRANCH >/dev/null 2>&1 || exit 1
  171. }
  172. uninstall() {
  173. set +e
  174. eval "$SUDO ./scripts/uninstall-mmgen.py"
  175. [ "$?" -ne 0 ] && { echo 'Uninstall failed, but proceeding anyway'; sleep 1; }
  176. set -e
  177. }
  178. install() {
  179. set -x
  180. eval "$SUDO rm -rf .test-release"
  181. git clone --branch $BRANCH --single-branch . .test-release
  182. (
  183. cd .test-release
  184. ./setup.py sdist
  185. mkdir pydist && cd pydist
  186. if [ "$MSYS2" ]; then unzip ../dist/mmgen-*.zip; else tar zxvf ../dist/mmgen-*gz; fi
  187. cd mmgen-*
  188. eval "$SUDO ./setup.py clean --all"
  189. [ "$MSYS2" ] && ./setup.py build --compiler=mingw32
  190. eval "$SUDO ./setup.py install --force"
  191. )
  192. set +x
  193. }
  194. do_test() {
  195. set +x
  196. tests="t_$1"
  197. skips="t_$1_skip"
  198. while read skip test; do
  199. [ "$test" ] || continue
  200. echo "${!skips}" | grep -q $skip && continue
  201. if [ "$LIST_CMDS" ]; then
  202. echo $test
  203. else
  204. test_disp=$YELLOW${test/\#/$RESET$MAGENTA\#}$RESET
  205. if [ "${test:0:1}" == '#' ]; then
  206. echo -e "$test_disp"
  207. else
  208. echo -e "${GREEN}Running:$RESET $test_disp"
  209. eval "$test" || {
  210. echo -e $RED"test-release.sh: test '$CUR_TEST' failed at command '$test'"$RESET
  211. exit 1
  212. }
  213. fi
  214. fi
  215. done <<<${!tests}
  216. }
  217. i_misc='Miscellaneous'
  218. s_misc='Testing various subsystems'
  219. t_misc="
  220. - $altcoin_py
  221. "
  222. f_misc='Miscellaneous tests completed'
  223. i_obj='Data object'
  224. s_obj='Testing data objects'
  225. t_obj="
  226. - $objtest_py --coin=btc
  227. - $objtest_py --getobj --coin=btc
  228. - $objtest_py --coin=btc --testnet=1
  229. - $objtest_py --coin=ltc
  230. - $objtest_py --coin=ltc --testnet=1
  231. - $objtest_py --coin=eth
  232. - $objattrtest_py
  233. "
  234. f_obj='Data object tests completed'
  235. i_color='Color'
  236. s_color='Testing terminal colors'
  237. t_color="- $colortest_py"
  238. f_color='Terminal color tests completed'
  239. i_dep='Dependency'
  240. s_dep='Testing for installed dependencies'
  241. t_dep="- $unit_tests_py testdep dep daemon.exec"
  242. f_dep='Dependency tests completed'
  243. i_unit='Unit'
  244. s_unit='The bitcoin and bitcoin-bchn mainnet daemons must be running for the following tests'
  245. t_unit="- $unit_tests_py --exclude testdep,dep,daemon"
  246. f_unit='Unit tests completed'
  247. i_hash='Internal hash function implementations'
  248. s_hash='Testing internal hash function implementations'
  249. t_hash="
  250. 256 $python test/hashfunc.py sha256 $rounds_max
  251. 512 $python test/hashfunc.py sha512 $rounds_max # native SHA512 - not used by the MMGen wallet
  252. keccak $python test/hashfunc.py keccak $rounds_max
  253. "
  254. f_hash='Hash function tests completed'
  255. [ "$ARM32" ] && t_hash_skip='512' # gmpy produces invalid init constants
  256. [ "$MSYS2" ] && t_hash_skip='512 keccak' # 2:py_long_long issues, 3:no pysha3 for keccak reference
  257. [ "$SKIP_ALT_DEP" ] && t_hash_skip+=' keccak'
  258. i_ref='Miscellaneous reference data'
  259. s_ref='The following tests will test some generated values against reference data'
  260. t_ref="
  261. - $scrambletest_py
  262. "
  263. f_ref='Miscellaneous reference data tests completed'
  264. i_altref='Altcoin reference file'
  265. s_altref='The following tests will test some generated altcoin files against reference data'
  266. t_altref="
  267. - $test_py ref_altcoin # generated addrfiles verified against checksums
  268. "
  269. f_altref='Altcoin reference file tests completed'
  270. i_alts='Gen-only altcoin'
  271. s_alts='The following tests will test generation operations for all supported altcoins'
  272. t_alts="
  273. - # speed tests, no verification:
  274. - $gentest_py --coin=etc 2 $rounds
  275. - $gentest_py --coin=etc --use-internal-keccak-module 2 $rounds_min
  276. - $gentest_py --coin=eth 2 $rounds
  277. - $gentest_py --coin=eth --use-internal-keccak-module 2 $rounds_min
  278. - $gentest_py --coin=xmr 2 $rounds
  279. - $gentest_py --coin=xmr --use-internal-keccak-module 2 $rounds_min
  280. - $gentest_py --coin=zec 2 $rounds
  281. - $gentest_py --coin=zec --type=zcash_z 2 $rounds_mid
  282. - # verification against external libraries and tools:
  283. - # pycoin
  284. - $gentest_py --all --type=legacy 2:pycoin $rounds
  285. - $gentest_py --all --type=compressed 2:pycoin $rounds
  286. - $gentest_py --all --type=segwit 2:pycoin $rounds
  287. - $gentest_py --all --type=bech32 2:pycoin $rounds
  288. - $gentest_py --all --type=legacy --testnet=1 2:pycoin $rounds
  289. - $gentest_py --all --type=compressed --testnet=1 2:pycoin $rounds
  290. - $gentest_py --all --type=segwit --testnet=1 2:pycoin $rounds
  291. - $gentest_py --all --type=bech32 --testnet=1 2:pycoin $rounds
  292. - # keyconv
  293. - $gentest_py --all --type=legacy 2:keyconv $rounds
  294. - $gentest_py --all --type=compressed 2:keyconv $rounds
  295. - # ethkey
  296. - $gentest_py --all 2:ethkey $rounds
  297. "
  298. [ "$MSYS2" ] || { # no moneropy (pysha3), zcash-mini (golang)
  299. t_alts+="
  300. - # moneropy
  301. - $gentest_py --all --coin=xmr 2:moneropy $rounds_min # very slow, be patient!
  302. - # zcash-mini
  303. - $gentest_py --all 2:zcash-mini $rounds_mid
  304. "
  305. }
  306. f_alts='Gen-only altcoin tests completed'
  307. create_tmpdir() {
  308. if [ "$MSYS2" ]; then
  309. TMPDIR='/tmp/mmgen-test-release'
  310. else
  311. TMPDIR='/tmp/mmgen-test-release-'$(cat /dev/urandom | base32 - | head -n1 | cut -b 1-16)
  312. fi
  313. mkdir -p $TMPDIR
  314. }
  315. rm -rf /tmp/mmgen-test-release*
  316. create_tmpdir
  317. i_xmr='Monero xmrwallet'
  318. s_xmr='Testing xmrwallet operations'
  319. t_xmr="
  320. - $test_py --coin=xmr xmrwallet
  321. "
  322. f_xmr='Monero xmrwallet tests completed'
  323. i_eth='Ethereum'
  324. s_eth='Testing transaction and tracking wallet operations for Ethereum'
  325. t_eth="
  326. - $test_py --coin=eth --daemon-id=openethereum ethdev
  327. - $test_py --coin=eth --daemon-id=geth ethdev
  328. "
  329. f_eth='Ethereum tests completed'
  330. i_etc='Ethereum Classic'
  331. s_etc='Testing transaction and tracking wallet operations for Ethereum Classic'
  332. t_etc="
  333. - $test_py --coin=etc ethdev
  334. "
  335. f_etc='Ethereum Classic tests completed'
  336. i_autosign='Autosign'
  337. s_autosign='The bitcoin, bitcoin-bchn and litecoin mainnet and testnet daemons must be running for the following test'
  338. t_autosign="- $test_py autosign"
  339. f_autosign='Autosign test completed'
  340. i_autosign_btc='Autosign BTC'
  341. s_autosign_btc='The bitcoin mainnet and testnet daemons must be running for the following test'
  342. t_autosign_btc="- $test_py autosign_btc"
  343. f_autosign_btc='Autosign BTC test completed'
  344. i_autosign_live='Autosign Live'
  345. s_autosign_live="The bitcoin mainnet and testnet daemons must be running for the following test\n"
  346. s_autosign_live+="${YELLOW}Mountpoint, '/etc/fstab' and removable device must be configured "
  347. s_autosign_live+="as described in 'mmgen-autosign --help'${RESET}"
  348. t_autosign_live="- $test_py autosign_live"
  349. f_autosign_live='Autosign Live test completed'
  350. i_btc='Bitcoin mainnet'
  351. s_btc='The bitcoin (mainnet) daemon must both be running for the following tests'
  352. t_btc="
  353. - $test_py --exclude regtest,autosign,ref_altcoin
  354. - $test_py --segwit
  355. - $test_py --segwit-random
  356. - $test_py --bech32
  357. - $python scripts/compute-file-chksum.py $REFDIR/*testnet.rawtx >/dev/null 2>&1
  358. "
  359. f_btc='Bitcoin mainnet tests completed'
  360. i_btc_tn='Bitcoin testnet'
  361. s_btc_tn='The bitcoin testnet daemon must both be running for the following tests'
  362. t_btc_tn="
  363. - $test_py --testnet=1
  364. - $test_py --testnet=1 --segwit
  365. - $test_py --testnet=1 --segwit-random
  366. - $test_py --testnet=1 --bech32
  367. "
  368. f_btc_tn='Bitcoin testnet tests completed'
  369. i_btc_rt='Bitcoin regtest'
  370. s_btc_rt="The following tests will test MMGen's regtest (Bob and Alice) mode"
  371. t_btc_rt="- $test_py regtest"
  372. f_btc_rt='Regtest (Bob and Alice) mode tests for BTC completed'
  373. i_bch='BitcoinCashNode (BCH) mainnet'
  374. s_bch='The bitcoin-bchn mainnet daemon must both be running for the following tests'
  375. t_bch="- $test_py --coin=bch --exclude regtest"
  376. f_bch='BitcoinCashNode (BCH) mainnet tests completed'
  377. i_bch_tn='BitcoinCashNode (BCH) testnet'
  378. s_bch_tn='The bitcoin-bchn testnet daemon must both be running for the following tests'
  379. t_bch_tn="- $test_py --coin=bch --testnet=1 --exclude regtest"
  380. f_bch_tn='BitcoinCashNode (BCH) testnet tests completed'
  381. i_bch_rt='BitcoinCashNode (BCH) regtest'
  382. s_bch_rt="The following tests will test MMGen's regtest (Bob and Alice) mode"
  383. t_bch_rt="- $test_py --coin=bch regtest"
  384. f_bch_rt='Regtest (Bob and Alice) mode tests for BCH completed'
  385. i_ltc='Litecoin'
  386. s_ltc='The litecoin mainnet daemon must both be running for the following tests'
  387. t_ltc="
  388. - $test_py --coin=ltc --exclude regtest
  389. - $test_py --coin=ltc --segwit
  390. - $test_py --coin=ltc --segwit-random
  391. - $test_py --coin=ltc --bech32
  392. "
  393. f_ltc='Litecoin mainnet tests completed'
  394. i_ltc_tn='Litecoin testnet'
  395. s_ltc_tn='The litecoin testnet daemon must both be running for the following tests'
  396. t_ltc_tn="
  397. - $test_py --coin=ltc --testnet=1 --exclude regtest
  398. - $test_py --coin=ltc --testnet=1 --segwit
  399. - $test_py --coin=ltc --testnet=1 --segwit-random
  400. - $test_py --coin=ltc --testnet=1 --bech32
  401. "
  402. f_ltc_tn='Litecoin testnet tests completed'
  403. i_ltc_rt='Litecoin regtest'
  404. s_ltc_rt="The following tests will test MMGen's regtest (Bob and Alice) mode"
  405. t_ltc_rt="- $test_py --coin=ltc regtest"
  406. f_ltc_rt='Regtest (Bob and Alice) mode tests for LTC completed'
  407. i_tool2='Tooltest2'
  408. s_tool2="The following tests will run '$tooltest2_py' for all supported coins"
  409. t_tool2="
  410. - $tooltest2_py --tool-api # test the tool_api subsystem
  411. - $tooltest2_py --tool-api --testnet=1
  412. - $tooltest2_py --tool-api --coin=eth
  413. - $tooltest2_py --tool-api --coin=xmr
  414. - $tooltest2_py --tool-api --coin=zec
  415. - $tooltest2_py
  416. - $tooltest2_py --testnet=1
  417. - $tooltest2_py --coin=ltc
  418. - $tooltest2_py --coin=ltc --testnet=1
  419. - $tooltest2_py --coin=bch
  420. - $tooltest2_py --coin=bch --testnet=1
  421. - $tooltest2_py --coin=zec
  422. - $tooltest2_py --coin=xmr
  423. - $tooltest2_py --coin=dash
  424. e $tooltest2_py --coin=eth
  425. e $tooltest2_py --coin=eth --testnet=1
  426. e $tooltest2_py --coin=eth --token=mm1
  427. e $tooltest2_py --coin=eth --token=mm1 --testnet=1
  428. e $tooltest2_py --coin=etc
  429. - $tooltest2_py --fork # run once with --fork so commands are actually executed
  430. "
  431. f_tool2='tooltest2 tests completed'
  432. [ "$SKIP_ALT_DEP" ] && t_tool2_skip='e' # skip ETH,ETC: txview requires py_ecc
  433. i_tool='Tooltest'
  434. s_tool="The following tests will run '$tooltest_py' for all supported coins"
  435. t_tool="
  436. - $tooltest_py --coin=btc cryptocoin
  437. - $tooltest_py --coin=btc mnemonic
  438. - $tooltest_py --coin=ltc cryptocoin
  439. - $tooltest_py --coin=eth cryptocoin
  440. - $tooltest_py --coin=etc cryptocoin
  441. - $tooltest_py --coin=dash cryptocoin
  442. - $tooltest_py --coin=doge cryptocoin
  443. - $tooltest_py --coin=emc cryptocoin
  444. - $tooltest_py --coin=zec cryptocoin
  445. z $tooltest_py --coin=zec --type=zcash_z cryptocoin
  446. "
  447. [ "$MSYS2" ] && t_tool_skip='z'
  448. f_tool='tooltest tests completed'
  449. i_gen='Gentest'
  450. s_gen="The following tests will run '$gentest_py' for BTC and LTC mainnet and testnet"
  451. t_gen="
  452. - # speed tests, no verification:
  453. - $gentest_py --coin=btc 2 $rounds
  454. - $gentest_py --coin=btc --type=compressed 2 $rounds
  455. - $gentest_py --coin=btc --type=segwit 2 $rounds
  456. - $gentest_py --coin=btc --type=bech32 2 $rounds
  457. - $gentest_py --coin=ltc 2 $rounds
  458. - $gentest_py --coin=ltc --type=compressed 2 $rounds
  459. - $gentest_py --coin=ltc --type=segwit 2 $rounds
  460. - $gentest_py --coin=ltc --type=bech32 2 $rounds
  461. - # wallet dumps:
  462. - $gentest_py 2 $REFDIR/btcwallet.dump
  463. - $gentest_py --type=segwit 2 $REFDIR/btcwallet-segwit.dump
  464. - $gentest_py --type=bech32 2 $REFDIR/btcwallet-bech32.dump
  465. - $gentest_py --testnet=1 2 $REFDIR/btcwallet-testnet.dump
  466. - $gentest_py --coin=ltc 2 $REFDIR/litecoin/ltcwallet.dump
  467. - $gentest_py --coin=ltc --type=segwit 2 $REFDIR/litecoin/ltcwallet-segwit.dump
  468. - $gentest_py --coin=ltc --type=bech32 2 $REFDIR/litecoin/ltcwallet-bech32.dump
  469. - $gentest_py --coin=ltc --testnet=1 2 $REFDIR/litecoin/ltcwallet-testnet.dump
  470. - # libsecp256k1 vs python-ecdsa:
  471. - $gentest_py 1:2 $rounds
  472. - $gentest_py --type=segwit 1:2 $rounds
  473. - $gentest_py --type=bech32 1:2 $rounds
  474. - $gentest_py --testnet=1 1:2 $rounds
  475. - $gentest_py --testnet=1 --type=segwit 1:2 $rounds
  476. - $gentest_py --coin=ltc 1:2 $rounds
  477. - $gentest_py --coin=ltc --type=segwit 1:2 $rounds
  478. - $gentest_py --coin=ltc --testnet=1 1:2 $rounds
  479. - $gentest_py --coin=ltc --testnet=1 --type=segwit 1:2 $rounds
  480. "
  481. f_gen='gentest tests completed'
  482. [ -d .git -a -n "$INSTALL" -a -z "$LIST_CMDS" ] && {
  483. check
  484. uninstall
  485. install
  486. cd .test-release/pydist/mmgen-*
  487. }
  488. [ "$INSTALL_ONLY" ] && exit
  489. prompt_skip() {
  490. echo -n "Enter 's' to skip, or ENTER to continue: "; read -n1; echo
  491. [ "$REPLY" == 's' ] && return 0
  492. return 1
  493. }
  494. run_tests() {
  495. [ "$LIST_CMDS" ] || echo "Running tests: $1"
  496. for t in $1; do
  497. if [ "$SKIP_ALT_DEP" ]; then
  498. ok=$(for a in $noalt_tests; do if [ $t == $a ]; then echo 'ok'; fi; done)
  499. if [ ! "$ok" ]; then
  500. echo -e "${BLUE}Skipping altcoin test '$t'$RESET"
  501. continue
  502. fi
  503. fi
  504. if [ "$LIST_CMDS" ]; then
  505. eval echo -e '\\n#' $(echo \$i_$t) "\($t\)"
  506. else
  507. eval echo -e "'\n'"\${GREEN}'###' Running $(echo \$i_$t) tests\$RESET
  508. eval echo -e $(echo \$s_$t)
  509. fi
  510. [ "$PAUSE" ] && prompt_skip && continue
  511. CUR_TEST=$t
  512. do_test $t
  513. [ "$LIST_CMDS" ] || eval echo -e $(echo \$f_$t)
  514. done
  515. }
  516. check_args() {
  517. for i in $tests; do
  518. echo "$dfl_tests $extra_tests" | grep -q "\<$i\>" || {
  519. echo "$i: unrecognized argument"
  520. exit 1
  521. }
  522. done
  523. }
  524. remove_skipped_tests() {
  525. tests=$(for t in $tests; do
  526. [ "$(for s in $SKIP_LIST; do [ $t == $s ] && echo y; done)" ] && continue
  527. echo $t
  528. done)
  529. tests=$(echo $tests)
  530. }
  531. remove_skipped_tests
  532. check_args
  533. start_time=$(date +%s)
  534. run_tests "$tests"
  535. elapsed=$(($(date +%s)-start_time))
  536. elapsed_fmt=$(printf %02d:%02d $((elapsed/60)) $((elapsed%60)))
  537. [ "$LIST_CMDS" ] || {
  538. if [ "$MMGEN_TEST_SUITE_DETERMINISTIC" ]; then
  539. echo -e "${GREEN}All OK"
  540. else
  541. echo -e "${GREEN}All OK. Total elapsed time: $elapsed_fmt$RESET"
  542. fi
  543. }